#include"motor.h"

Motor::Motor(int e, int a,int b,int c,int d,float f)
{
  en=e; // Motorpins merken
  m1=a;
  m2=b;
  i1=c;
  i2=d;
  mmps=f;
  
  pinMode(en,OUTPUT); // Pins konfigurieren
  pinMode(m1,OUTPUT);
  pinMode(m2,OUTPUT);
  pinMode(i1,INPUT);
  pinMode(i2,INPUT);

  talt=micros(); // Zeit in Mikrosekunden

  int h = digitalRead(i1)+2*digitalRead(i2); // Aktuellen Zustand ermitteln
  int i;
  for(i=0;i<3;i++) if (st[i]==h) pos=i;
}

float Motor::getS()
{
  return steps*mmps;
}

float Motor::getV() //Geschwindigkeit in mm/s
{
  if (micros()-talt>40000) f=0.0;
  return f*mmps;
}

void Motor::richtung()
{
  int h = digitalRead(i1)+2*digitalRead(i2);
  tneu=micros(); // Aktuelle Zeit;
  if (st[(pos+3)%4]==h)
  {
    steps--;  
    pos=(pos+3)%4;
  }  
  else if (st[(pos+1)%4]==h)
  {
    steps++;  
    pos=(pos+1)%4;
  }
  if (pos==0)
  {
    tneu=micros(); // Aktuelle Zeit;
    f=1000000.0*float(steps-stepsalt)/float(tneu-talt);
    talt=tneu;
    stepsalt=steps;
  }
}

long Motor::getSteps()
{
  return steps;
}

float Motor::getF()
{
  if (micros()-talt>40000) f=0.0;
  return f;
}

void Motor::power(int p)
{
  p=constrain(p,-255,255);
  if(p>=0)
  {
    analogWrite(en,p);
    digitalWrite(m1,HIGH);
    digitalWrite(m2,LOW);
  }
  else
  {
    analogWrite(en,-p);
    digitalWrite(m2,HIGH);
    digitalWrite(m1,LOW);
  }
}

